#include "AttributeLexer.h"

#include <sstream>
#include <iostream>

namespace { //The automaton data
    typedef std::size_t State;

    State REJECT = 13;

    unsigned char TRANS_IDX[256] = { (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)1, (unsigned char)2, (unsigned char)3, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)4, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)5, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)2, (unsigned char)2, (unsigned char)7, (unsigned char)8, (unsigned char)9, (unsigned char)2, (unsigned char)2, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)0, (unsigned char)2, (unsigned char)0, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)6, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)2, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0, (unsigned char)0,  };

    State TABLE[14 - 1][10] = { 
        {  13,  4,  13,  8,  10,  13,  5,  1,  7,  12,  },
        
        {  13,  2,  13,  13,  13,  2,  3,  13,  13,  13,  },
        
        {  13,  2,  13,  13,  13,  13,  3,  13,  13,  13,  },
        
        {  13,  13,  13,  13,  13,  13,  3,  13,  13,  13,  },
        
        {  13,  4,  13,  8,  10,  13,  13,  13,  7,  13,  },
        
        {  13,  6,  13,  13,  13,  13,  5,  13,  7,  13,  },
        
        {  13,  6,  13,  13,  13,  13,  13,  13,  7,  13,  },
        
        {  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,  },
        
        {  13,  8,  8,  9,  8,  8,  8,  13,  8,  13,  },
        
        {  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,  },
        
        {  13,  10,  10,  10,  11,  10,  10,  13,  10,  13,  },
        
        {  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,  },
        
        {  13,  13,  13,  13,  13,  13,  13,  13,  13,  13,  },
         };

    AttributeLexer::TokenType TOKENS[14] = {  AttributeLexer::WHITESPACE,  AttributeLexer::ELEMENT,  AttributeLexer::ELEMENT,  AttributeLexer::ELEMENT,  AttributeLexer::WHITESPACE,  AttributeLexer::nonmatching,  AttributeLexer::nonmatching,  AttributeLexer::ATTRIBUTE,  AttributeLexer::nonmatching,  AttributeLexer::ATTRIBUTE_CONTENT_DOUBLE_QUOTES,  AttributeLexer::nonmatching,  AttributeLexer::ATTRIBUTE_CONTENT_SINGLE_QUOTES,  AttributeLexer::BRACKET,  AttributeLexer::nonmatching,  };
}

AttributeLexer::AttributeLexer(std::istream& in) : m_offset(0), m_input(in) {

}

AttributeLexer::~AttributeLexer() {
}

AttributeLexer::Token AttributeLexer::nextToken() {
    TokenType type = ignore;
    std::string token;

    while (type == ignore) {
        State state = 0;
        std::size_t match_length = 0;
        token = "";

        while (!m_input.eof() && state != REJECT) {
            char c = m_input.peek();
            if (m_input.eof())
                break;

            token += c;

            state = TABLE[state][TRANS_IDX[(unsigned char)c]];
            if (TOKENS[state])
            {
                match_length = token.length();
                type = TOKENS[state];
            }
            m_input.get();
            ++m_offset;
        }

        std::size_t sdiff = token.length() - match_length;
        for (std::size_t i = 0; i < sdiff; i++)
        {
            m_input.putback(token[token.length() - i - 1]);
        }
        m_offset -= sdiff;

        if (!type || !match_length) {
            if (m_input.eof())
                throw NoMoreTokens();
            throw NoMatch();
        }

        token = token.substr(0, match_length);
    }

    Token t;
    t.type = type;
    t.content = token;
    return t;
}

void AttributeLexer::skip(std::size_t n) {
    for (size_t i = 0; i < n; i++) {
        m_input.get();
        ++m_offset;
    }
}

char AttributeLexer::peek() {
    if (m_input.eof())
        throw NoMoreTokens();
    return m_input.peek();
}

std::size_t AttributeLexer::getByteOffset() {
    return m_offset;
}
